// Header File
// Created 08/07/2005; 09:56:10
#ifndef __HAWK_animations_H__
#define __HAWK_animations_H__

//==========================================================================//
//	Dcalage de la liste 'animation' (pareil que 'DecaleListeBombesEtProj'
//	mais avec le type 'ANIM')
//==========================================================================//

void DecaleListeAnims(ANIM * liste, short indice, short dim)
{
	register short i;
	
	for(i = indice; i <= dim-1; i ++)
	{
		liste[i] = liste[i+1];
	}
	
}

//==========================================================================//
//	Initialisation d'une animation
//==========================================================================//

void InitAnims(void)
{	
	register short i;
	
	
	for(i = last_anim+1; i <= last_anim+indiks_anims[mode][indice_global][0]; i ++)
	{
		animation[i].cycles_anim = indiks_anims[mode][indice_global][1];
		animation[i].indice_anim = indiks_anims[mode][indice_global][8];
		animation[i].etape_anim = 0;
		animation[i].hauteur = indiks_anims[mode][indice_global][2];
		animation[i].largeur = indiks_anims[mode][indice_global][3];
		animation[i].x = indiks_anims[mode][indice_global][15+2*(i-1-last_anim)];
		animation[i].y = indiks_anims[mode][indice_global][16+2*(i-1-last_anim)];
		animation[i].compteur_incr = indiks_anims[mode][indice_global][7]*(last_anim+indiks_anims[mode][indice_global][0]-i);
		animation[i].tempo = indiks_anims[mode][indice_global][4];
		animation[i].compteur = 0;
		animation[i].dead = TEMPO_CLIGNO_DEAD*(indiks_anims[mode][indice_global][6]-1);
		animation[i].indice_incr = indice_global;
		animation[i].flag_proj = indiks_anims[mode][indice_global][9];
		if(indiks_anims[mode][indice_global][9] == AVEC_PROJ)
		{
			animation[i].x_proj_offset = indiks_anims[mode][indice_global][10];
			animation[i].y_proj_offset = indiks_anims[mode][indice_global][11];
			animation[i].x_proj_incr = indiks_anims[mode][indice_global][12];
			animation[i].y_proj_incr = indiks_anims[mode][indice_global][13];
			animation[i].tempo_proj = indiks_anims[mode][indice_global][14];
		}
	}
	
	last_anim += indiks_anims[mode][indice_global][0];
	
}

//==========================================================================//
//	Affichage des animations
//==========================================================================//

void AfficheAnims(void)
{
	if(last_anim == NOTHING)
	{
		return;
	}
	 
	register short i;
	
	for(i = 0; i <= last_anim; i ++)
	{
		if((animation[i].x < -animation[i].largeur && incr_anims[mode][animation[i].indice_incr][2*animation[i].compteur_incr] < 0) || (animation[i].x > 160 && incr_anims[mode][animation[i].indice_incr][2*animation[i].compteur_incr] > 0) || (animation[i].y < -animation[i].hauteur && incr_anims[mode][animation[i].indice_incr][2*animation[i].compteur_incr+1] < 0))
		{
			DecaleListeAnims(animation, i, last_anim);
			last_anim --;
			i --;
			continue;
		}
		 
		if(animation[i].dead%TEMPO_CLIGNO_DEAD == 0)
		{
			GrayClipSprite32_MASK_R(animation[i].x, animation[i].y, animation[i].hauteur+2, animations_0+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), animations_1+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), animations_mask+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), animations_mask+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), vscreen_0, vscreen_1);
		}
		else
		{
			GrayClipSprite32_AND_R(animation[i].x, animation[i].y, animation[i].hauteur+2, animations_mask+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), animations_mask+22*(debuts_anim[animation[i].indice_anim]+animation[i].etape_anim), vscreen_0, vscreen_1);
			animation[i].dead --;
		}
		animation[i].compteur_incr %= indiks_anims[mode][animation[i].indice_incr][5];
		animation[i].etape_anim += (animation[i].compteur%TEMPO_ANIMS_STEPS == 0 ? 1: 0);
		animation[i].etape_anim %= animation[i].cycles_anim;
		if(animation[i].x > 160 || animation[i].x < -animation[i].largeur)
		{
			animation[i].x += (animation[i].compteur%animation[i].tempo == 0 ? incr_anims[mode][animation[i].indice_incr][0]: 0);
			continue;
		}
		animation[i].compteur ++;
		animation[i].x += (animation[i].compteur%animation[i].tempo == 0 ? incr_anims[mode][animation[i].indice_incr][2*animation[i].compteur_incr]: 0);
		animation[i].y += (animation[i].compteur%animation[i].tempo == 0 ? incr_anims[mode][animation[i].indice_incr][2*animation[i].compteur_incr+1]: 0);
		if(animation[i].compteur%10 == 0)
		{
			animation[i].compteur_incr ++;
		}
		if(animation[i].flag_proj == AVEC_PROJ && animation[i].compteur%animation[i].tempo_proj == 0)
		{
			last_proj ++;
			liste_x_proj[last_proj] = animation[i].x+animation[i].x_proj_offset;
			liste_y_proj[last_proj] = animation[i].y+animation[i].y_proj_offset;
			liste_x_incr_proj[last_proj] = animation[i].x_proj_incr;
			liste_y_incr_proj[last_proj] = animation[i].y_proj_incr;
		}
	}
	
}

//==========================================================================//
//	Affichage des animations spciales (oeil, chambre  air ...)
//	(TEMPO_OEIL = 76 pour EASY, 62 pour HARD)
//	Signification de flag_oeil:
//	-  -1: rien;
//	- de 0  23: animation oeil;
//	-  24: lche une boule;
//	- de 25  48: animation oeil (sens inverse);
//	- de 49  TEMPO_OEIL-1: animation 0 de l'oeil;
//	-  TEMPO_OEIL: remise  zro;
//	- de TEMPO_OEIL+1  TEMPO_OEIL+24: l'oeil a t touch: animation de l'explosion de l'oeil.
//
//==========================================================================//

void AfficheAnimsSpeciales(void)
{
	register short i;
	
	if(flag_oeil != NOTHING)
	{
		x_oeil --;
		flag_oeil ++;
		
		if(oeil_dead == 0 && flag_oeil < TEMPO_OEIL+25)
		{
			GrayClipSprite32_MASK_R(x_oeil+2, y_oeil, 18, oeil_expl_0+18*((flag_oeil-(TEMPO_OEIL+1))/6), oeil_expl_1+18*((flag_oeil-(TEMPO_OEIL+1))/6), mask_oeil_expl, mask_oeil_expl, vscreen_0, vscreen_1);
			goto suivante;
		}
		if(flag_oeil == TEMPO_OEIL+25 || x_oeil < -18)
		{
			flag_oeil = NOTHING;
			if(flag_oeil == 101)
			{
				score += 175+100*mode;
				morts ++;
			}
			goto suivante;
		}
	
		if(flag_oeil < 24)
		{
			GrayClipSprite32_MASK_R(x_oeil, y_oeil, 18, oeil_0+18*(flag_oeil/6), oeil_1+18*(flag_oeil/6), mask_oeil, mask_oeil, vscreen_0, vscreen_1);
		}
		else if(flag_oeil > 24 && flag_oeil < 49)
		{
			GrayClipSprite32_MASK_R(x_oeil, y_oeil, 18, oeil_0+18*((48-flag_oeil)/6), oeil_1+18*((48-flag_oeil)/6), mask_oeil, mask_oeil, vscreen_0, vscreen_1);
		}
		else if(flag_oeil > 48)
		{
			GrayClipSprite32_MASK_R(x_oeil, y_oeil, 18, oeil_0, oeil_1, mask_oeil, mask_oeil, vscreen_0, vscreen_1);
		}
		else if(flag_oeil == 24)	// Un projectile est lanc !
		{
			GrayClipSprite32_MASK_R(x_oeil, y_oeil, 18, oeil_0+54, oeil_1+54, mask_oeil, mask_oeil, vscreen_0, vscreen_1);
			last_proj ++;
			liste_x_proj[last_proj] = x_oeil-4;
			liste_y_proj[last_proj] = y_oeil+4;
			liste_x_incr_proj[last_proj] = -2;
			liste_y_incr_proj[last_proj] = 0;
		};
		
		flag_oeil %= TEMPO_OEIL;
	}
	
	suivante:
	
	if(flag_mur != NOTHING)
	{
		x_mur --;
		
		if(x_mur < -18)
		{
			flag_mur = NOTHING;
		}
		else if(x_mur == 195)
		{
			flag_mur = -2;
		}
	}
	
	if(last_trompe != NOTHING)
	{
		for(i = 0; i <= last_trompe; i ++)
		{
			if(liste_x_trompe[i] >= 100 && liste_x_trompe[i] <= 117)
			{
				GraySprite32_MASK_R(liste_x_trompe[i], liste_y_trompe[i], 26, trompe_0+26*(liste_flag_trompe[i]/6), trompe_1+26*(liste_flag_trompe[i]/6), trompe_mask+26*(liste_flag_trompe[i]/6), trompe_mask+26*(liste_flag_trompe[i]/6), vscreen_0, vscreen_1);
				liste_flag_trompe[i] ++;
				if(liste_x_trompe[i] == 108)
				{
					last_anim ++;
					animation[last_anim].cycles_anim = 3;
					animation[last_anim].indice_anim = BALLE;
					animation[last_anim].etape_anim = 0;
					animation[last_anim].hauteur = 14;
					animation[last_anim].largeur = 14;
					animation[last_anim].x = 108;
					animation[last_anim].y = liste_y_trompe[i]+24;
					animation[last_anim].compteur_incr = 0;
					animation[last_anim].tempo = TEMPO_BORDS;
					animation[last_anim].compteur = 0;
					animation[last_anim].dead = TEMPO_CLIGNO_DEAD;
					animation[last_anim].indice_incr = 0;
				}
			}
			else
			{
				GrayClipSprite32_MASK_R(liste_x_trompe[i], liste_y_trompe[i], 26, trompe_0, trompe_1, trompe_mask, trompe_mask, vscreen_0, vscreen_1);	
			}
		
			liste_x_trompe[i] --;
		
			if(liste_x_trompe[i] < -18)
			{
				last_trompe --;	
				DecaleListeBombesEtProj(liste_x_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_y_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_flag_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_dead_trompe, i, NB_MAX_TROMPES);
				i --;
			}
		
		}
	}
}

//==========================================================================//

void AfficheProjectiles(void)
{
	if(last_proj == NOTHING)
	{
		return;
	}
	 
	register short i;
	
	for(i = 0; i <= last_proj; i ++)
	{
		GrayClipSprite16_MASK_R(liste_x_proj[i], liste_y_proj[i], 10, proj_0, proj_1, mask_proj, mask_proj, vscreen_0, vscreen_1);
		liste_x_proj[i] += liste_x_incr_proj[i];
		liste_y_proj[i] += liste_y_incr_proj[i];
		if(liste_x_proj[i] < -9 || liste_y_proj[i] < -10)
		{
			last_proj --;
			DecaleListeBombesEtProj(liste_x_proj, i, NB_MAX_PROJ);
			DecaleListeBombesEtProj(liste_y_proj, i, NB_MAX_PROJ);
			DecaleListeBombesEtProj(liste_x_incr_proj, i, NB_MAX_PROJ);
			DecaleListeBombesEtProj(liste_y_incr_proj, i, NB_MAX_PROJ);
		}
	}
}

//==========================================================================//

void AfficheBonus(void)
{
	if(flag_bonus == NOTHING)
	{
		return;
	}
	
	x_bonus --;
	GrayClipSprite32_MASK_R(x_bonus, y_bonus, 18, bonus_0+18*(flag_bonus), bonus_1+18*(flag_bonus), bonus_mask, bonus_mask, vscreen_0, vscreen_1);
	
	if(x_bonus < -19)
	{
		flag_bonus = NOTHING;
	}
}

//==========================================================================//

#endif