// Header File
// Created 28/06/2005; 14:26:31
#ifndef __HAWK_bombes_H__
#define __HAWK_bombes_H__

//==========================================================================//
//	Initialise les bombes en fonction de la taille du canon
//==========================================================================//

void InitBombes(short x, short y)
{
	register short i;
	
	for(i = 0; i < taille_canon; i ++)
	{
		last_bombe ++;
		liste_x_bombes[last_bombe] = x+21;
		liste_y_bombes[last_bombe] = y+offset_y_bombes[taille_canon-1][i];
	}
}

//==========================================================================//

short CollisionVaisseauBonus(short x, short y)
{
	if(flag_bonus == NOTHING)
	{
		return 0;
	}
	
	if(x+17 >= x_bonus && x <= x_bonus+17 && y >= y_bonus-14 && y <= y_bonus+16)
	{
		return 1;
	}
	
	return 0;
}

//==========================================================================//
//	Dtecte si au moins un des 16 pixels au-dessus ou au-dessous du vaisseau
//	est noir (ie, allum sur les deux plans)
//==========================================================================//

unsigned short CollisionVaisseauBords(short x, short y)
{
	// Petite optimisation
	register unsigned short * ptr = (unsigned short *)(mask_bords+30*y+((x>>3)&0xFFFE));
	return !(*ptr&0xFFFF);
	
	/*register unsigned short * ptr_0 = (unsigned short *)(screen_bords_0+30*y+((x>>3)&0xFFFE));
	register unsigned short * ptr_1 = (unsigned short *)(screen__bords_1+30*y+((x>>3)&0xFFFE));
	return (*ptr_0&0xFFFF)&(*ptr_1&0xFFFF);*/
}

//==========================================================================//

short CollisionVaisseauAnims(short x, short y)
{
	register short i;
	
	for(i = 0; i <= last_anim; i ++)
	{
		if((x+20 >= animation[i].x && x <= animation[i].x+animation[i].largeur) && (y >= animation[i].y-15 && y <= animation[i].y+animation[i].hauteur-2))
		{
			return 1;
		}
	}
	
	return 0;
}

//==========================================================================//

short CollisionVaisseauAnimsSpeciales(short x, short y)
{
	register short i;
	
	if(flag_oeil != NOTHING)
	{
		if(x+22 >= x_oeil && x <= x_oeil+20 && y >= y_oeil-15 && y <= y_oeil+18)
		{
			return 1;	
		}
	}
	
	if(last_trompe != NOTHING)
	{
		for(i = 0; i <= last_trompe; i ++)
		{
			if(x+22 >= liste_x_trompe[i] && x <= liste_x_trompe[i]+18 && y >= liste_y_trompe[i]-15 && y <= liste_y_trompe[i]+24)
			{
				return 1;
			}
		}
	}
	
	return 0;
}

//==========================================================================//

short CollisionVaisseauProjectiles(short x, short y)
{
	if(last_proj == NOTHING)
	{
		return 0;
	}
	
	register short i;
	
	for(i = 0; i <= last_proj; i ++)
	{
		if(x+22 >= liste_x_proj[i] && x <= liste_x_proj[i]+8 && y >= liste_y_proj[i]-15 && y <= liste_y_proj[i]+7)
		{
			return 1;
		}	
	}
	
	return 0;
}

//==========================================================================//

short CollisionVaisseau(short x, short y)
{
	if(CollisionVaisseauBords(x+1, y+1) || CollisionVaisseauBords(x+1, y+16) || CollisionVaisseauAnims(x, y) || CollisionVaisseauAnimsSpeciales(x, y) || CollisionVaisseauProjectiles(x, y))
	{
		return 1;
	}
	 
	return 0;
}

//==========================================================================//

short CollisionBombesAnims(short x, short y) // Retourne l'indice de l'animation touche
{
	register short i;
	
	for(i = 0; i <= last_anim; i ++)
	{
		if((x+8 >= animation[i].x && x <= animation[i].x+animation[i].largeur+2) && (y+2 >= animation[i].y-2 && y <= animation[i].y+animation[i].hauteur))
		{
			return i;
		}
	}
	
	return NOTHING;
}

//==========================================================================//

short CollisionBombesOeil(short x, short y)
{
	if(flag_oeil == NOTHING || flag_oeil >= TEMPO_OEIL)
	{
		return 0;
	}
	 
	if(x+7 >= x_oeil && x <= x_oeil+18 && y+5 >= y_oeil && y <= y_oeil+14)
	{
		oeil_dead --;
		score += 5*(6-lives);
		if(oeil_dead == 0)
		{
			flag_oeil = TEMPO_OEIL;
		}
		return 1;
	}
	
	return 0;
}

//==========================================================================//

short CollisionBombesBords(short x, short y)
{
	if(EXT_GETPIX(screen_bords_0, x+8, y+2) || EXT_GETPIX(screen_bords_1, x+8, y+2) || EXT_GETPIX(screen_bords_0, x+8, y+3) || EXT_GETPIX(screen_bords_1, x+8, y+3) || EXT_GETPIX(screen_bords_0, x+8, y+4) || EXT_GETPIX(screen_bords_0, x+8, y+4))
	{
		return 1;
	}
	 
	return 0;
}

//==========================================================================//

short CollisionBombesMur(short x, short y)
{
	if(flag_mur == NOTHING)
	{
		return 0;
	}
	 
	register short i, j, k;
	i = abs(x+8-x_mur)/9;
	j = abs(y+2-y_mur_haut)/8;
	k = abs(y+4-y_mur_haut)/8;
	
	if(CollisionBombesBords(x, y) && x+7 >= x_mur && x <= x_mur+18 && y+3 >= y_mur_haut && y <= y_mur_bas-5)
	{
		GrayFastFillRect_R(screen_bords_0, screen_bords_1, x_mur-1+9*i, y_mur_haut+8*j, x_mur-1+9*(i+1), y_mur_haut+8*(j+1)-1, COLOR_WHITE);
		FastFilledRect_Draw_R(mask_bords, x_mur-1+9*i, y_mur_haut+8*j, x_mur-1+9*(i+1), y_mur_haut+8*(j+1));
		GrayFastFillRect_R(screen_bords_0, screen_bords_1, x_mur-1+9*i, y_mur_haut+8*k, x_mur-1+9*(i+1), y_mur_haut+8*(k+1)-1, COLOR_WHITE);
		FastFilledRect_Draw_R(mask_bords,x_mur-1+9*i, y_mur_haut+8*k, x_mur+9*(i+1), y_mur_haut+8*(k+1));
		return 1;
	}
	
	return 0;
}

//==========================================================================//

short CollisionBombesTrompe(short x, short y)
{
	if(last_trompe == NOTHING)
	{
		return 0;
	}
	 
	register short i;
	
	for(i = 0; i <= last_trompe; i ++)
	{
		if(x+7 >= liste_x_trompe[i] && x <= liste_x_trompe[i]+18 && y+3 >= liste_y_trompe[i] && y <= liste_y_trompe[i]+23)
		{
			score += 5*(6-lives);
			if((-- liste_dead_trompe[i]) == 0)
			{
				last_trompe --;	
				DecaleListeBombesEtProj(liste_x_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_y_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_flag_trompe, i, NB_MAX_TROMPES);
				DecaleListeBombesEtProj(liste_dead_trompe, i, NB_MAX_TROMPES);
				score += 175+100*mode;
				morts ++;
			}
			return 1;
		}
	}
	
	return 0;
}

//==========================================================================//

void InitListes(void)
{
	register short i;
	
	for(i = 0; i < NB_MAX_BOMBES; i ++)
	{
		liste_x_bombes[i] = 0xFF;
		liste_y_bombes[i] = 0xFF;
		liste_flags[i] = 0xFF;
	}
}

//==========================================================================//

void DecaleListeBombesEtProj(short * liste, short indice, short dim)
{
	register short i;
	
	for(i = indice; i <= dim-2; i ++)	// dim-2 car NB_MAX_BOMBES est le nombre d'lments de la liste et non pas l'indice maximal !
	{
		liste[i] = liste[i+1];
	}
	
	liste[dim-1] = 0xFF;
}

//==========================================================================//
//	Quelques normes:
//	Lorsqu'un lment n'est plus actif (la bombe a dj explos ou dpass les
//	les limites de l'cran), les listes liste_x_bombes, liste_y_bombes et
//	liste_flags sont remplies par 0xFF.
//	Lorsqu'une bombe entre en collision avec qqchose, liste_flags = 0.
//	Cette liste prend ensuite les valeurs de 0  4*TEMPO_EXPLOSION_BOMBE:
//	valeur/TEMPO_EXPLOSION_BOMBE = numro de l'explosion, temporisation aussi.
//	Dcalage des listes ensuite et rinitialisation, etc.
//==========================================================================//

void AfficheBombes(void)
{
	if(last_bombe == NOTHING)
	{
		return;
	}
	 
	register short i, j;
			
	for(i = 0; i <= last_bombe; i ++)
	{
		if(liste_flags[i] == 0xFF)
		{
			if(last_anim != NOTHING)	// Collision avec les animations
			{
				j = CollisionBombesAnims(liste_x_bombes[i], liste_y_bombes[i]);
				if(j != -1)
				{
					score += 5*(6-lives);
					
					if(animation[j].dead == 0)
					{
						morts ++;
						score += 165+5*(6-lives)*animation[j].indice_anim+100*mode;
						liste_flags[i] = 0;
						DecaleListeAnims(animation, j, last_anim);
						last_anim --;
					}
					else
					{
						animation[j].dead --;
						liste_flags[i] = 200;
					}
					
				}	 	
			}
			
			if(CollisionBombesMur(liste_x_bombes[i], liste_y_bombes[i]))
			{
				liste_flags[i] = 0;
				continue;
			}
			
			if(CollisionBombesBords(liste_x_bombes[i], liste_y_bombes[i]) || CollisionBombesOeil(liste_x_bombes[i], liste_y_bombes[i]) || CollisionBombesTrompe(liste_x_bombes[i], liste_y_bombes[i])) // Collision avec les bords ou les anims spciales
			{
				liste_flags[i] = 0;	// Avec explosion =)
			}
			
			GraySprite16_MASK_R(liste_x_bombes[i], liste_y_bombes[i], 10, bombe_0+10*(indice_vaisseau), bombe_1+10*(indice_vaisseau), bombe_mask+10*(indice_vaisseau), bombe_mask+10*(indice_vaisseau), vscreen_0, vscreen_1);
			liste_x_bombes[i] += 3;
		}
		else
		{
			liste_flags[i] ++;
			if(liste_flags[i] < 4*TEMPO_EXPLOSION_BOMBE)
			{
				GrayClipSprite32_MASK_R(liste_x_bombes[i]-12, liste_y_bombes[i]-14, 32, explosion_0+32*(liste_flags[i]/TEMPO_EXPLOSION_BOMBE), explosion_1+32*(liste_flags[i]/TEMPO_EXPLOSION_BOMBE), explosion_mask+32*(liste_flags[i]/TEMPO_EXPLOSION_BOMBE), explosion_mask+32*(liste_flags[i]/TEMPO_EXPLOSION_BOMBE), vscreen_0, vscreen_1);
			}
			else
			{
				liste_flags[i] = 200;
			}
		}
		
		if(liste_x_bombes[i] > 160 || liste_flags[i] == 200)
		{
			liste_x_bombes[i] = 0xFF;
			liste_y_bombes[i] = 0xFF;
			liste_flags[i] = 0xFF;
			last_bombe --;
			DecaleListeBombesEtProj(liste_x_bombes, i, NB_MAX_BOMBES);
			DecaleListeBombesEtProj(liste_y_bombes, i, NB_MAX_BOMBES);
			DecaleListeBombesEtProj(liste_flags, i, NB_MAX_BOMBES);
			i --;
		}
	}
}

//==========================================================================//

#endif